/*
 *	Copyright (c) 1997 Rinet Corp., Novosibirsk, Russia
 *
 * Redistribution and use in source forms, with and without modification,
 * are permitted provided that this entire comment appears intact.
 *
 * THIS SOURCE CODE IS PROVIDED ``AS IS'' WITHOUT ANY WARRANTIES OF ANY KIND.
 */

#ifndef	_TNS_VARIABLES_H_
#define	_TNS_VARIABLES_H_

extern char *getvariables(char *var);
extern void insvariables(char *var);
extern void setvariables(char *var);

/* List of internal variables */

#define	SYSTEMTIME	"SYSTEMTIME"	/* Current system time	*/
#define	ONLINETIME	"ONLINETIME"	/* Time	in on-line	*/
#define	FILEAREAPATH	"FILEAREAPATH"	/* FileArea path	*/
#define	FILEAREADIR	"FILEAREADIR"	/* FileArea directory	*/
#define	UPLOADPATH	"UPLOADPATH"	/* Upload Area path	*/
#define	UPLOADDIR	"UPLOADDIR"	/* Upload directory	*/
#define	MSGAREAPATH	"MSGAREAPATH"	/* MsgArea path		*/
#define	MSGAREADIR	"MSGAREADIR"	/* MsgArea directory	*/
#define	MSGNUMMSG	"MSGNUMMSG"	/* Number of messages	*/
#define	USENETGROUP	"USENETGROUP"	/* Usenet group name	*/
#define	SHORTKEYS	"SHORTKEYS"	/* Menu short keys	*/
#define	USERPRIVLEVEL	"PRIVLEVEL"	/* User Privlevel	*/
#define	MENUPATH	"MENUPATH"	/* Menu path		*/
#define	MENUDIR		"MENUDIR"	/* Menu directory	*/
#define	USERTIMELEFT	"TIMELEFT"	/* Time left		*/
#define	SESSIONTIME	"SESSIONTIME"	/* Max session time	*/
#define	USER		"USER"		/* User name		*/
#define	USERGROUP	"GROUP"		/* Group of user	*/
#define	REALNAME	"REALNAME"	/* User real name	*/
#define	EMAIL		"EMAIL"		/* E-mail of user	*/
#define	CALLSIGN	"CALLSIGN"	/* User call signature	*/
#define	SIGNATURE	"SIGNATURE"	/* User signature	*/
#define	USERLOCATION	"LOCATION"	/* User Sity/State	*/
#define	PASSWORD	"PASSWORD"	/* Encrypted password	*/
#define	USERORG		"ORGANIZATION"	/* User Organization	*/
#define	PROTOCOL	"PROTOCOL"	/* Default protocol	*/
#define	LANGUAGE	"LANGUAGE"	/* Language		*/
#define	LANGNUMBER	"LANGNUMBER"	/* Language number	*/
#define	CODEPAGE	"CODEPAGE"	/* CodePage number	*/
#define	DAILYDLSIZE	"DAILYDLSIZE"	/* User daily Download	*/
#define	DAILYULSIZE	"DAILYULSIZE"	/* User daily Upload	*/
#define	USERDLSIZE	"USERDLSIZE"	/* User Download	*/
#define	USERULSIZE	"USERULSIZE"	/* User Upload		*/
#define	DAILYDLLIMIT	"DAILYDLLIMIT"	/* Daily Download limit	*/
#define	SYSDLULRATIO	"SYSDLULRATIO"	/* System DL/UL ratio	*/
#define	USERDLULRATIO	"USERDLULRATIO"	/* User DL/UL ratio	*/
#define	ULMULTIPLIER	"ULMULTIPLIER"	/* UL multiplier	*/
#define	CALLNUMBER	"CALLNUMBER"	/* Number of calls	*/
#define	SCRLINES	"SCRLINES"	/* Lines on screen	*/
#define	SYSTEMNAME	"SYSTEMNAME"	/* Name of this system	*/
#define	MYHOSTNAME	"MYHOSTNAME"	/* Host of this system	*/
#define	SYSMAILTO	"SYSMAILTO"	/* Name of this system	*/
#define	SYSADMNAME	"SYSADMNAME"	/* Name of this system	*/
#define	USERSTATUS	"USERSTATUS"	/* User status		*/
#define	USERSTATE	"USERSTATE"	/* User state		*/
#define	LASTCALLTIME	"LASTCALLTIME"	/* User Last Call Time	*/
#define	TERM		"TERM"		/* User terminal type	*/
#define	PHONE		"PHONE"		/* User phone number	*/
#define	NEWSSORT	"NEWSSORT"	/* NewsSort string	*/
#define	ARTREADLIMIT	"ARTREADLIMIT"	/* ArtRead limit	*/
#define	ARTSIZELIMIT	"ARTSIZELIMIT"	/* ArtSize limit	*/
#define	ARTPOSTLIMIT	"ARTPOSTLIMIT"	/* ArtPost limit	*/
#define	MSGREADLIMIT	"MSGREADLIMIT"	/* MsgRead limit	*/
#define	MSGPOSTLIMIT	"MSGPOSTLIMIT"	/* MsgPost limit	*/
#define	USERARTREAD	"ARTREAD"	/* How many Art readed	*/
#define	USERARTSIZE	"ARTSIZE"	/* How much Art posted	*/
#define	USERARTPOST	"ARTPOST"	/* How many Art posted	*/
#define	USERMSGREAD	"MSGREAD"	/* How many Msg readed	*/
#define	USERMSGPOST	"MSGPOST"	/* How many Msg posted	*/
#define	DOTTEDNAME	"DOTTEDNAME"	/* DottedName John.Doe	*/
#define	PID		"PID"		/* My PID		*/
#define	TTY		"TTY"		/* My tty		*/
#define	TIMERATE	"TIMERATE"	/* timerate divisor	*/
#define	INTERRUPT	"INTERRUPT"	/* interrupt rate	*/
#define	HOTKEY		"HOTKEY"	/* hotkey yes/no	*/
#define	SHORTMENU	"SHORTMENU"	/* shortmenu yes/no	*/
#define	MESG		"MESG"		/* mesg status yes/no	*/
#define	HOMEDIR		"HOME"		/* bbs user home dir	*/
#define	ORGDIR		"ORGDIR"	/* bbs system orig dir	*/
#define	CONNECT		"CONNECT"	/* connect speed	*/
#define	DISPLAY		"DISPLAY"	/* exec display() func	*/
#define	USERKICKER	"KICKER"	/* set/unset kicker	*/
#define	FINGER		"FINGER"	/* set/show finger prgm	*/
#define	TALK		"TALK"		/* set/show talk prgm	*/
#define	FTPSERVER	"FTPSERVER"	/* connected FTP server	*/
#define	FTPPWD		"FTPPWD"	/* current work dir	*/
#define	READFILESDIR	"READFILESDIR"	/* readfiles dir name	*/
#define	LINE		"LINE"		/* login line descript	*/
#define	REMOTEADDR	"REMOTEADDR"	/* remote addr (telnet)	*/
#define	REMOTEHOST	"REMOTEHOST"	/* remote host (telnet)	*/
#define	TIMEGET		"TIMEGET"

#define	PACKAGE		"ID"		/* software ident	*/
#define	VERSION		"VER"		/* version number	*/
#define	TARGET		"OS"		/* operating system	*/
#define	COMPILED	"CC"		/* was compiled with	*/

#endif	/* !_TNS_VARIABLES_H_ */
